Skip to main content
POST
cURL

Authorizations

Authorization
string
header
required

Your Stability API key, sent as a bearer token in the Authorization header.

Headers

Accept
enum<string>
default:application/json

The format of the response. Leave blank for JSON, or set to 'image/png' for a PNG image.

Available options:
application/json,
image/png
Organization
string

Allows for requests to be scoped to an organization other than the user's default. If not provided, the user's default organization will be used.

Stability-Client-ID
string

Used to identify the source of requests, such as the client application or sub-organization. Optional, but recommended for organizational clarity.

Stability-Client-Version
string

Used to identify the version of the application or service making the requests. Optional, but recommended for organizational clarity.

Path Parameters

engine_id
string
required

Body

multipart/form-data

Represents the optional parameters that can be passed to any generation request.

text_prompts
object[]
required

An array of text prompts to use for generation.

Due to how arrays are represented in multipart/form-data requests, prompts must adhere to the format text_prompts[index][text|weight], where index is some integer used to tie the text and weight together. While index does not have to be sequential, duplicate entries will override previous entries, so it is recommended to use sequential indices.

Given a text prompt with the text A lighthouse on a cliff and a weight of 0.5, it would be represented as:

To add another prompt to that request simply provide the values under a new index:

Minimum array length: 1
init_image
file
required

Image used to initialize the diffusion process, in lieu of random noise.

mask_source
string
required

For any given pixel, the mask determines the strength of generation on a linear scale. This parameter determines where to source the mask from:

  • MASK_IMAGE_WHITE will use the white pixels of the mask_image as the mask, where white pixels are completely replaced and black pixels are unchanged
  • MASK_IMAGE_BLACK will use the black pixels of the mask_image as the mask, where black pixels are completely replaced and white pixels are unchanged
  • INIT_IMAGE_ALPHA will use the alpha channel of the init_image as the mask, where fully transparent pixels are completely replaced and fully opaque pixels are unchanged
mask_image
file
required

Optional grayscale mask that allows for influence over which pixels are eligible for diffusion and at what strength. Must be the same dimensions as the init_image. Use the mask_source option to specify whether the white or black pixels should be inpainted.

cfg_scale
number
default:7

How strictly the diffusion process adheres to the prompt text (higher values keep your image closer to your prompt)

Required range: 0 <= x <= 35
Example:

7

clip_guidance_preset
enum<string>
default:NONE
Available options:
FAST_BLUE,
FAST_GREEN,
NONE,
SIMPLE,
SLOW,
SLOWER,
SLOWEST
Example:

"FAST_BLUE"

sampler
enum<string>

Which sampler to use for the diffusion process. If this value is omitted we'll automatically select an appropriate sampler for you.

Available options:
DDIM,
DDPM,
K_DPMPP_2M,
K_DPMPP_2S_ANCESTRAL,
K_DPM_2,
K_DPM_2_ANCESTRAL,
K_EULER,
K_EULER_ANCESTRAL,
K_HEUN,
K_LMS
Example:

"K_DPM_2_ANCESTRAL"

samples
integer
default:1

Number of images to generate

Required range: 1 <= x <= 10
Example:

1

seed
integer
default:0

Random noise seed (omit this option or use 0 for a random seed)

Required range: 0 <= x <= 4294967295
Example:

0

steps
integer
default:30

Number of diffusion steps to run.

Required range: 10 <= x <= 50
Example:

50

style_preset
enum<string>

Pass in a style preset to guide the image model towards a particular style. This list of style presets is subject to change.

Available options:
enhance,
anime,
photographic,
digital-art,
comic-book,
fantasy-art,
line-art,
analog-film,
neon-punk,
isometric,
low-poly,
origami,
modeling-compound,
cinematic,
3d-model,
pixel-art,
tile-texture
extras
object

Extra parameters passed to the engine. These parameters are used for in-development or experimental features and may change without warning, so please use with caution.

Response

Generation successful.

An array of results from the generation request, where each image is a base64 encoded PNG.

artifacts
object[]